<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
class Manage extends MY_Controller {

    function __construct() {
        parent::__construct();
        $this->load->model('M_user', 'database');
        if($this->aauth->is_loggedin()===FALSE){ redirect('logout'); }
    }

    function index() {
        $data['page'] ='User/dashboard_user';
        $this->template->admin($data);
    }

    function edit($enc_id) {
        $id= base64_decode($enc_id);
        $da['user']=$this->aauth->get_user($id);
        $data['page'] ='User/edit_user';
        $this->template->admin($data);
    }


    function user_list() {
        $data['page'] ='User/user_list';
        $this->template->admin($data);
    }

    function group_list() {
        $data['kewenangan'] = $this->aauth->list_groups();
        $data['page'] ='User/group_list';
        $this->template->admin($data);
    }
    function json_user_list() {
        header('Content-Type: application/json');
        $data = $row = array();
        $Datatable = $this->database->getRows($_POST);
        $i = $_POST['start'];
        foreach($Datatable as $r){
            $notif_yang_diterima="";
            $id_telegram = $this->aauth->get_user_var('id_telegram',$r->id);
            $notif_permohonan = $this->aauth->get_user_var('notif_permohonan',$r->id);
            $notif_stok = $this->aauth->get_user_var('notif_stok',$r->id);
            if ($id_telegram =="") {
                $id_telegram = '<code>Warning ID Telegram belum ada</code></a>';
            }
            if ($notif_permohonan){
                $notif_yang_diterima .= "Notifikasi Permohonan<br>ID : ".$id_telegram."<br>";
            }
            if ($notif_stok){
                $notif_yang_diterima .= "Notifikasi Stok Akan Habis<br>ID : ".$id_telegram."<br>";
            }
            $id_satker = $this->aauth->get_user_var('id_satker',$r->id);
            $get_satker  = $this->db->get_where('satker',array('id'=>$id_satker))->row();
            if ($get_satker !="") {
                $satker_text=$get_satker->satker_text;
            }else{
                $satker_text ='<code>Tidak terhubung dengan Satwil</code></td></tr>';
            }
            $tombol_aksi = '<div class="text-center"><span class="btn-group btn-group-sm mr-2">
                <a href="'.base_url('User/Manage/detil/').base64_encode($this->encryption->encrypt($r->id)).'" class="btn btn-white btn-sm"><i class="fa fa-fw fa-edit"></i> <span class="hidden-xs">Detil</span></a>
            </span></div>';
            if ($r->banned==0){
                $banned='Tidak';
            }else{
                $banned='<label class="text-danger">Diblokir</label>';
            }
            $i++;
            $group = $this->aauth->get_user_groups($r->id)[0];
            if ($group->id==1){
                $group_name = '<i class="fa fa-star text-success"> </i> '.$group->definition.' <i class="fa fa-star text-success"> </i>';
            }else if ($group->id==2) {
                $group_name = '<i class="fa fa-user-circle text-warning"> </i> '.$group->definition.' <i class="fa fa-user-circle text-warning"> </i> ';
            }else{
                $group_name = '<i class="fa fa-street-view"> </i> '.$group->definition;
            }
            $data[] = array($i,
                            substr_replace($r->email,'****',5),
                            'Username : <b>'.$r->username.'</b><br>'.$group_name.'<br>Satwil : '.$satker_text,
                            $banned,
                            $notif_yang_diterima,
                            $tombol_aksi);
        }

        $output = array(
            "draw" => $_POST['draw'],
            "recordsTotal" => $this->database->countAll(),
            "recordsFiltered" => $this->database->countFiltered($_POST),
            "data" => $data,
        );

        echo json_encode($output);
   }

   function detil($enc_id) {
        if($this->aauth->is_member('admin')===FALSE){ redirect('dashboard'); }
        $id=$this->encryption->decrypt(base64_decode($enc_id));
        $id_satker = $this->aauth->get_user_var('id_satker',$id);
        $id_telegram = $this->aauth->get_user_var('id_telegram',$id);
        $id_pegawai = $this->aauth->get_user_var('id_pegawai',$id);
        $notif_permohonan = $this->aauth->get_user_var('notif_permohonan',$id);
        $notif_stok = $this->aauth->get_user_var('notif_stok',$id);
        $group = $this->aauth->get_user_groups($id)[0];

        $get_pegawai = $this->db->get_where('pegawai',array('id'=>$id_pegawai))->row();
        $get_satker  = $this->db->get_where('satker',array('id'=>$id_satker))->row();
        $get_user = $this->aauth->get_user($id);

        if ($id_telegram =="") {
            $id_telegram = '<code>Belum terhubung dengan Telegram</code><br><a class="btn btn-sm btn-primary text-white" data-target="#popupTelegram" data-toggle="modal">Input ID Telegram</a>';
        }

        if ($get_user !="") {
            $info_user= '<tr>
                <td>Email</td>
                <td>'.$get_user->email.'</td>
              </tr>
              <tr>
                <td>Username</td>
                <td>'.$get_user->username.'</td>
              </tr>
              <tr>
                <td>ID Telegram</td>
                <td>'.$id_telegram.'</td>
              </tr>
              <tr>
                <td>Group User</td>
                <td>'.$group->name.'-'.$group->definition.'</td>
              </tr>
              <tr>
                <td>Status Blokir : </td>
                <td>'.($get_user->banned == 0 ? "Tidak" : "Diblokir ".'<a href="#" class="btn btn-sm bg-primary text-white" onclick="unblock_user(\''.$enc_id.'\')" ><i class="fa fa-unlock text-white"></i> Buka Blokir</a>').'</td>
              </tr>
              <tr>
                <td>Last Login</td>
                <td>'.date( 'd-m-Y H:i:s',strtotime($get_user->last_login)).'</td>
              </tr>
              <tr>
                <td>Didaftarkan tanggal</td>
                <td>'.date( 'd-m-Y H:i:s',strtotime($get_user->date_created)).'</td>
              </tr>';
        }else{
            $info_user ='<small>Error</small> ';
        }
        if ($get_satker !="") {
            $satker_text=$get_satker->satker_text;
        }else{
            $satker_text ='<code>Tidak terhubung dengan satker manapun</code><br><tr><td>Edit</td><td><a class="btn btn-sm btn-primary text-white" data-target="#popupSatker" data-toggle="modal">Pilih Satker</a></td></tr>';
        }
        if ($get_pegawai!=""){
            $data['info_variable'] = '<table class="table">
                                        <tr><td>Nama</td><td>'.$get_pegawai->nama_gelar.'</td></tr>
                                        <tr><td>NRP</td><td>'.$get_pegawai->nip.'</td></tr>
                                        <tr><td>Pangkat - Golongan</td><td>'.$get_pegawai->pangkat.' - '.$get_pegawai->golongan.'</td></tr>
                                        <tr><td>Alamat</td><td>'.$get_pegawai->alamat.'</td><tr>
                                        <tr><td>Satuan Kerja</td><td>'.$satker_text.'</td><tr>
                                    </table>';
        }else{
             $data['info_variable'] = '<table class="table">
                                        <tr><td><code>User ini tidak terhubung dengan pegawai manapun</code></td></tr>
                                        <tr><td><a class="btn btn-primary btn-sm text-white" data-target="#popupPegawai" data-toggle="modal">Pilih Pegawai</a></td></tr>
                                        <tr><td>'.$satker_text.'</td><tr>
                                      </table>';

        }
        $action_user = '<div class="list-group">';
        $action_user .='<a href="#" class="list-group-item bg-dark text-white" data-target="#popupTelegram" data-toggle="modal"><i class="fa fa-paper-plane text-white"></i> Ganti ID Telegram</a>';
        $action_user .='<a href="#" class="list-group-item bg-dark text-white" data-target="#popupSatker" data-toggle="modal"><i class="fa fa-university text-white"></i> Ganti Satker</a>';
        $action_user .='<a href="#" class="list-group-item bg-dark text-white" data-target="#popupPegawai" data-toggle="modal"><i class="fa fa-user text-white"></i> Ganti Pegawai</a>';
        $action_user .='<a href="#" class="list-group-item bg-dark text-white" data-target="#popupPassword" data-toggle="modal"><i class="fa fa-wrench text-white"></i> Ganti Email / Username / Password</a>';
        $action_user .='<a href="#" class="list-group-item bg-dark text-white" data-target="#popupGroup" data-toggle="modal"><i class="fa fa-users text-white"></i> Ganti Group User</a>';
        $action_user .='<a href="#" class="list-group-item bg-warning text-white" onclick="block_user(\''.$enc_id.'\')" ><i class="fa fa-lock text-white"></i> Blokir User</a>';
        $action_user .='<a href="#" class="list-group-item bg-danger text-white" onclick="delete_user(\''.$enc_id.'\')"><i class="fa fa-trash text-white"></i> Hapus User</a>';
        $action_user .= '</div>';

        $data['notif_permohonan'] = $notif_permohonan;
        $data['notif_stok'] = $notif_stok;
        $data['action_user'] = $action_user;
        $data['enc_id'] = $enc_id;
        $data['list_group'] = $this->all_group($enc_id);
        $data['list_pegawai'] = $this->all_pegawai($enc_id);
        $data['list_satker'] = $this->all_satker($enc_id);
        $data['info_user'] = $info_user;
        $data['page'] ='User/detil_user';
        $this->template->admin($data);
    }

    function all_group($enc_id){
        $group = $this->aauth->list_groups();
        $hasil = '<div class="list-group">';
        for ($i=0; $i <count($group) ; $i++) {
        $hasil  .= '<div class="btn-group">';
            $hasil .= '<a href="#" onclick="konek_to_group(\''.$group[$i]->name.'\','.'\''.$group[$i]->id.'\',\''.$enc_id.'\')" class="list-group-item list-group-item-action">'.$group[$i]->name.'</a>';
            $hasil .= '<a href="#" onclick="konek_to_group(\''.$group[$i]->name.'\','.'\''.$group[$i]->id.'\',\''.$enc_id.'\')" class="list-group-item list-group-item-action">'.$group[$i]->definition.'</a>';
            $hasil  .= '</div>';
        }
        $hasil .= '</div>';
        return $hasil;
    }

    function all_pegawai($enc_id){
        $pegawai = $this->db->query('select * from pegawai');
        $hasil = '<div class="list-group">';
        foreach ($pegawai->result() as $r) {
        $hasil  .= '<div class="btn-group">';
            $hasil .= '<a href="#" onclick="konek_to_pegawai(\''.$r->nama_gelar.'\','.'\''.$r->id.'\',\''.$enc_id.'\')" class="list-group-item list-group-item-action">'.$r->nama_gelar.'</a>';
            $hasil .= '<a href="#" onclick="konek_to_pegawai(\''.$r->nama_gelar.'\','.'\''.$r->id.'\',\''.$enc_id.'\')" class="list-group-item list-group-item-action">'.$r->nip.'</a>';
            $hasil  .= '</div>';
        }
        $hasil .= '</div>';
        return $hasil;
    }

     function all_satker($enc_id){
        $satker = $this->db->query('select * from satker');
        $hasil = '<div class="list-group">';
        foreach ($satker->result() as $r) {
            $hasil .= '<a href="#" onclick="konek_to_satker(\''.$r->satker_text.'\','.'\''.$r->id.'\',\''.$enc_id.'\')" class="list-group-item list-group-item-action">'.$r->satker_text.'</a>';
        }
        $hasil .= '</div>';
        return $hasil;
    }
    function assign_pegawai(){
        $pegawai_id=$this->input->post('pegawai_id');
        $enc_id = $this->input->post('enc_id');
        $user_id = $this->encryption->decrypt(base64_decode($enc_id));
        $this->aauth->unset_user_var("id_pegawai",$user_id);
        if ($this->aauth->set_user_var('id_pegawai',$pegawai_id, $user_id)){
            echo json_encode(array('st'=>1));
            return;
        }
        echo json_encode(array('st'=>0));
        return;
    }
    function assign_notif(){
        $jenis=$this->input->post('jenis');
        $nilai=$this->input->post('nilai');
        $enc_id = $this->input->post('enc_id');
        $user_id = $this->encryption->decrypt(base64_decode($enc_id));
        if ($nilai==1){
            $this->aauth->set_user_var($jenis,$nilai,$user_id);
            echo json_encode(array('st'=>1,'jenis'=>$jenis, 'value'=>1));
        }else{
            $this->aauth->unset_user_var($jenis,$user_id);
            echo json_encode(array('st'=>1,'jenis'=>$jenis, 'value'=>0));
        }
        return;
    }

    function assign_satker(){
        $satker_id=$this->input->post('satker_id');
        $enc_id = $this->input->post('enc_id');
        $user_id = $this->encryption->decrypt(base64_decode($enc_id));
        $this->aauth->unset_user_var("id_satker",$user_id);
        if ($this->aauth->set_user_var('id_satker',$satker_id, $user_id)){
            echo json_encode(array('st'=>1));
            return;
        }
        echo json_encode(array('st'=>0));
        return;
    }

    function assign_group(){
        $group_id=$this->input->post('group_id');
        $enc_id = $this->input->post('enc_id');
        $user_id = $this->encryption->decrypt(base64_decode($enc_id));
        $this->db->delete('aauth_user_to_group',array('user_id'=>$user_id));
        if ($this->aauth->add_member($user_id,$group_id)){
            echo json_encode(array('st'=>1));
            return;
        }
        echo json_encode(array('st'=>0));
        return;
    }

    function update_password(){
        $email=$this->input->post('email');
        $username = $this->input->post('username');
        $password = $this->input->post('password');
        $enc_id = $this->input->post('enc_id');
        if ($email=="") $email=FALSE;
        if ($username=="") $username=FALSE;
        if ($password=="") $password=FALSE;
        $user_id = $this->encryption->decrypt(base64_decode($enc_id));

        $update_user=$this->aauth->update_user($user_id, $email, $password, $username);
        if ($update_user) {
            echo json_encode(array('st'=>1,'msg'=>'User sudah di update'));
            return;
        }
        echo json_encode(array('st'=>0,'msg'=>'User sudah di update'));
        return;
    }

    function assign_telegram(){
        $id_telegram=$this->input->post('id_telegram');
        $enc_id = $this->input->post('enc_id');
        $user_id = $this->encryption->decrypt(base64_decode($enc_id));
        $this->aauth->unset_user_var("id_telegram",$user_id);
        if ($this->aauth->set_user_var('id_telegram',$id_telegram, $user_id)){
            echo json_encode(array('st'=>1));
            return;
        }
        echo json_encode(array('st'=>0));
        return;
    }
    function log() {
        $data['page_title'] = 'Data Log';
        $data['page'] ='User/log_data';
        $this->template->admin($data);
    }

    function log_json_user() {
        header('Content-Type: application/json');
        echo $this->database->log_json_user();
   }

   function registrasi() {
        $data['page'] ='User/register';
        $this->template->admin($data);
    }

   function add_user() {
        $this->form_validation->set_rules('email', 'Email','trim|required|min_length[3]|max_length[100]|xss_clean');
        $this->form_validation->set_rules('password','Password','trim|required|min_length[8]|xss_clean');
        $this->form_validation->set_rules('username','Username','trim|required|min_length[5]|xss_clean');
        if ($this->form_validation->run() == FALSE) {
            echo json_encode(array('st'=>0,'msg'=> validation_errors()));
            return;
        }
        $eksekusi = $this->aauth->create_user($this->input->post('email'), $this->input->post('password'), $this->input->post('username'));
        $err = $this->aauth->get_errors_array();
        if($eksekusi) {
            if (strlen($err) < 1){
                // $err="Data berhasil disimpan";
                echo json_encode(array('st'=>1,'msg'=> $err ));
                return;
            }else{
               $err = implode("<br />", $err);
                echo json_encode(array('st'=>0,'msg'=> $err ));
                 return;
            }
        } else{
            echo json_encode(array('st'=>0,'msg'=>$err));
             return;
        }
    }

    function assign_block() {
        $enc_id = $this->input->post('enc_id');
        $user_id = $this->encryption->decrypt(base64_decode($enc_id));
        if ($this->aauth->ban_user($user_id)){
            echo json_encode(array('st'=>1));
            return;
        }
        echo json_encode(array('st'=>0));
        return;
    }

    function assign_unblock() {
        $enc_id = $this->input->post('enc_id');
        $user_id = $this->encryption->decrypt(base64_decode($enc_id));
        if ($this->aauth->unban_user($user_id)){
            echo json_encode(array('st'=>1));
            return;
        }
        echo json_encode(array('st'=>0));
        return;
    }
    function remove_user() {
        $enc_id = $this->input->post('enc_id');
        $user_id = $this->encryption->decrypt(base64_decode($enc_id));
        if ($this->aauth->delete_user($user_id)){
            echo json_encode(array('st'=>1));
            return;
        }
        echo json_encode(array('st'=>0));
        return;
    }

    function generate_permission(){
        $this->aauth->create_perm('menu_transaksi','Transaksi Masuk dan Keluar');
        $this->aauth->create_perm('menu_system','Menu System');
        $this->aauth->create_perm('menu_referensi','Menu Referensi');
        $this->aauth->create_perm('menu_referensi','Menu Referensi');
    }
}

