<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class TanggalHelper{
	public function __construct(){
		$this->mytanggal =& get_instance();
    }
	function monthName($str){
		if(preg_match('((?:Jan(?:uary)?|Feb(?:ruary)?|Mar(?:ch)?|Apr(?:il)?|May|Jun(?:e)?|Jul(?:y)?|Aug(?:ust)?|Sep(?:tember)?|Sept|Oct(?:ober)?|Nov(?:ember)?|Dec(?:ember)?))', $str)){
			$month = strtoupper($str);
				if(preg_match('((JAN(?:UARY)?))',$month)){
					$month = 'Januari';
				}elseif(preg_match('((FEB(?:RUARY)))',$month) or $month == 'FEB'){
					$month = 'Februari';
				}elseif(preg_match('((MAR(?:CH)?))',$month)){
					$month = 'Maret';
				}elseif(preg_match('((APR(?:IL)?))',$month)){
					$month = 'April';
				}elseif(preg_match('((MAY?))',$month)){
					$month = 'Mei';
				}elseif(preg_match('((JUN(?:E)?))',$month)){
					$month = 'Juni';
				}elseif(preg_match('((JUL(?:Y)?))',$month)){
					$month = 'Juli';
				}elseif(preg_match('((AUG(?:UST)?))',$month)){
					$month = 'Agustus';
				}elseif(preg_match('((SEP(?:TEMBER)?))',$month)){
					$month = 'September';
				}elseif(preg_match('((OCT(?:OBER)?))',$month)){
					$month = 'Oktober';
				}elseif(preg_match('((NOV(?:EMBER)?))',$month)){
					$month = 'November';
				}elseif(preg_match('((DEC(?:EMBER)?))',$month)){
					$month = 'Desember';
				}
			return $month;
		}
	}


	function monthNameFull($str){
		if($str=='01'){
			$month = 'Januari';
		}elseif($str=='02'){
			$month = 'Februari';
		}elseif($str=='03'){
			$month = 'Maret';
		}elseif($str=='04'){
			$month = 'April';
		}elseif($str=='05'){
			$month = 'Mei';
		}elseif($str=='06'){
			$month = 'Juni';
		}elseif($str=='07'){
			$month = 'Juli';
		}elseif($str=='08'){
			$month = 'Agustus';
		}elseif($str=='09'){
			$month = 'September';
		}elseif($str=='10'){
			$month = 'Oktober';
		}elseif($str=='11'){
			$month = 'November';
		}elseif($str=='12'){
			$month = 'Desember';
		}
		return $month;
	}


	function dayName($str){
		if(preg_match('((?:Monday|Tuesday|Wednesday|Thursday|Friday|Saturday|Sunday|Tues|Thur|Thurs|Sun|Mon|Tue|Wed|Thu|Fri|Sat))', $str)){

			$day = strtoupper($str);
			if(preg_match('|MONDAY|',$day)){
				$day = 'Senin';
			}elseif(preg_match('|TUESDAY|',$day)){
				$day = 'Selasa';
			}elseif(preg_match('|WEDNESDAY|',$day)){
				$day = 'Rabu';
			}elseif(preg_match('|THURSDAY|',$day)){
				$day = 'Kamis';
			}elseif(preg_match('|FRIDAY|',$day)){
				$day = 'Jumat';
			}elseif(preg_match('|SATURDAY|',$day)){
				$day = 'Sabtu';
			}elseif(preg_match('|SUNDAY|',$day)){
				$day = 'Minggu';
			}
			return $day;
		}
	}

	public function convertDayDate($str){
		if(preg_match("/^[0-9]{4}-(0[1-9]|1[0-2])-(0[1-9]|[1-2][0-9]|3[0-1])$/", $str)){
			$date = (date_format(date_create($str),'Y/M/d'));
			$dates = explode("/", $date);
			$hari = $this->dayName(date('l', strtotime($str)));
			return $hari.", ".$dates[2]." ".$this->monthName($dates[1])." ".$dates[0];
		}else{
			return " - ";
		}

	}
	public function convertDate($str){
		if(preg_match("/^[0-9]{4}-(0[1-9]|1[0-2])-(0[1-9]|[1-2][0-9]|3[0-1])$/", $str)){
			$date = (date_format(date_create($str),'Y/M/j'));
			$dates = explode("/", $date);
			return $dates[2]." ".$this->monthName($dates[1])." ".$dates[0];
		}else{
			return " - ";
		}
	}



	public function convertToInputDate($str){
		if(preg_match("/^[0-9]{4}-(0[1-9]|1[0-2])-(0[1-9]|[1-2][0-9]|3[0-1])$/", $str)){
			$date = (date_format(date_create($str),'d/m/Y'));
			$dates = explode("/", $date);
			return $date;
		}else{
			return "";
		}
	}

	public function getSelisihHari($date1,$date2){
	 	$date1 = strtotime($date1);
	 	$date2 = strtotime($date2);
	 	$datediff = $date2 - $date1;
	 	return floor($datediff/(60*60*24));
	}

	public function getSelisihBulan($date1,$date2){
	 	$date1 = strtotime($date1);
	 	$date2 = strtotime($date2);
	 	$datediff = $date2 - $date1;
	 	return floor($datediff/(30*60*60*24));
	}

	public function getSelisihTahun($date1,$date2){
		$diff = abs(strtotime($date2) - strtotime($date1));
		return floor($diff / (365*60*60*24));
	}

	public function convertToMysqlDate($date){
		$re1='((?:(?:[0-2]?\\d{1})|(?:[3][01]{1}))[-:\\/.](?:[0]?[1-9]|[1][012])[-:\\/.](?:(?:[1]{1}\\d{1}\\d{1}\\d{1})|(?:[2]{1}\\d{3})))(?![\\d])';	# DDMMYYYY 1
		if ($c=preg_match_all ("/".$re1."/is", $date, $matches)){
			$myDateTime = DateTime::createFromFormat('d/m/Y', $date);
			return $myDateTime->format('Y-m-d');
		}else{
			return false;
		}
	}
	public function getDayName($date){
		$status = True;
		$re1='((?:(?:[0-2]?\\d{1})|(?:[3][01]{1}))[-:\\/.](?:[0]?[1-9]|[1][012])[-:\\/.](?:(?:[1]{1}\\d{1}\\d{1}\\d{1})|(?:[2]{1}\\d{3})))(?![\\d])';	# DDMMYYYY 1
		if ($c=preg_match_all ("/".$re1."/is", $date, $matches)){
			$myDateTime = DateTime::createFromFormat('d/m/Y', $date);
			$date = $myDateTime->format('Y-m-d');
			$status = True;
			return date('l', strtotime($date));
		}else{
			$status = False;
		}
		$re2='((?:(?:[1]{1}\\d{1}\\d{1}\\d{1})|(?:[2]{1}\\d{3}))[-:\\/.](?:[0]?[1-9]|[1][012])[-:\\/.](?:(?:[0-2]?\\d{1})|(?:[3][01]{1})))(?![\\d])';	# YYYYMMDD 1
		if ($c=preg_match_all ("/".$re2."/is", $date, $matches)){
			$myDateTime = DateTime::createFromFormat('Y-m-d', $date);
			$date = $myDateTime->format('Y-m-d');
			return date('l', strtotime($date));
		}else{
			$status = false;
		}
		if($status == false){
			return 'Error, Date Invalid Format';
		}
		return date('l', strtotime($date));
	}



	function ucname($string) {
    	if (strpos($string, 'I-')!==false) {
    		$explode=explode(' ', $string);
    		foreach ($explode as $key => $value) {
    			if (strpos($value, 'I-')==false) {
    				$explode[$key] =ucwords(strtolower($value));
    			}
    		}
    		$string=implode(" ",$explode);
    	}else{
    		$string =ucwords(strtolower($string));
    	}


        foreach (array(',','.','-', '\'') as $delimiter) {
          if (strpos($string, $delimiter)!==false) {
          	$string =implode($delimiter, array_map('ucfirst', explode($delimiter, $string)));
          }
        }
        return $string;
    }


    public function namaKota($kota){
		$kotaucfirst = ucfirst($kota);
		$replace = array("PENGADILAN","NEGERI","AGAMA","agama","Agama","Pengadilan","Negeri","Kelas","MILITER","I", "Ia", "Ib","KHUSUS","TATA", "USAHA" ,"NEGARA","1","2","3","4","5","6","7","8","9","0","-");
		$namaKotax = ucfirst(str_replace($replace,"",$kotaucfirst));
		return ltrim($namaKotax);
	}

	public function  convertKeTglDatepicker($tgl){
	    $tanggal = substr($tgl,8,2);
	    $bulan   = substr($tgl,5,2);
	    $tahun   = substr($tgl,0,4);
	    return  $tanggal.'/'.$bulan.'/'.$tahun;
	}

	public function Terbilang($x){
		if ($x==''){
			$x=0;
		}
		$abil = array("", "satu", "dua", "tiga", "empat", "lima", "enam", "tujuh", "delapan", "sembilan", "sepuluh", "sebelas");
			if ($x < 12)
				return " " . $abil[$x];
			elseif ($x < 20)
    			return $this->Terbilang($x - 10) . " belas";
    		elseif ($x < 100)
    			return $this->Terbilang($x / 10) . " puluh" .$this->Terbilang($x % 10);
    		elseif ($x < 200)
    			return " seratus" .$this->Terbilang($x - 100);
    		elseif ($x < 1000)
    			return $this->Terbilang($x / 100) . " ratus" .$this->Terbilang($x % 100);
    		elseif ($x < 2000)
    			return " seribu" .$this->Terbilang($x - 1000);
    		elseif ($x < 1000000)
    			return $this->Terbilang($x / 1000) . " ribu" .$this->Terbilang($x % 1000);
    		elseif ($x < 1000000000)
    			return $this->Terbilang($x / 1000000) . " juta" .$this->Terbilang($x % 1000000);
	}

	function getHariKerja($date1, $date2, $workSat = FALSE, $patron = NULL) {
	  if (!defined('SATURDAY')) define('SATURDAY', 6);
	  if (!defined('SUNDAY')) define('SUNDAY', 0);
	  //tahun 2019
	  $publicHolidays = array('01-01', '02-05','03-07', '04-03','04-17','04-19', '05-01', '05-30',
	  							'06-03','06-04','06-05','06-06', '06-07', '08-12', '12-24', '12-25');
	  if ($patron) {
	    $publicHolidays[] = $patron;
	  }
	  $yearStart = date('Y', strtotime($date1));
	  $yearEnd   = date('Y', strtotime($date2));
	  for ($i = $yearStart; $i <= $yearEnd; $i++) {
	    $easter = date('Y-m-d', easter_date($i));
	    list($y, $m, $g) = explode("-", $easter);
	    $monday = mktime(0,0,0, date($m), date($g)+1, date($y));
	    $easterMondays[] = $monday;
	  }
	  $start = strtotime($date1);
	  $end   = strtotime($date2);
	  $workdays = 0;
	  for ($i = $start; $i <= $end; $i = strtotime("+1 day", $i)) {
	    $day = date("w", $i);  // 0=sun, 1=mon, ..., 6=sat
	    $mmgg = date('m-d', $i);
	    if ($day != SUNDAY &&
	      !in_array($mmgg, $publicHolidays) &&
	      !in_array($i, $easterMondays) &&
	      !($day == SATURDAY && $workSat == FALSE)) {
	        $workdays++;
	    }
	  }
	  return intval($workdays);
	}

	function time_elapsed_string($datetime, $full = false) {
	    $now = new DateTime;
	    $ago = new DateTime($datetime);
	    $diff = $now->diff($ago);

	    $diff->w = floor($diff->d / 7);
	    $diff->d -= $diff->w * 7;

	    $string = array(
	        'y' => 'year',
	        'm' => 'month',
	        'w' => 'week',
	        'd' => 'day',
	        'h' => 'hour',
	        'i' => 'minute',
	        's' => 'second',
	    );
	    foreach ($string as $k => &$v) {
	        if ($diff->$k) {
	            $v = $diff->$k . ' ' . $v . ($diff->$k > 1 ? 's' : '');
	        } else {
	            unset($string[$k]);
	        }
	    }

	    if (!$full) $string = array_slice($string, 0, 1);
	    return $string ? implode(', ', $string) . ' ago' : 'just now';

	}

	function time_passed_string($datetime, $full = false) {
	    $now = new DateTime;
	    $further = new DateTime($datetime);
	    $diff = $now->diff($further);

	    $diff->w = floor($diff->d / 7);
	    $diff->d -= $diff->w * 7;

	    $string = array(
	        'y' => 'tahun',
	        'm' => 'bulan',
	        'w' => 'minggu',
	        'd' => 'hari',
	        'h' => 'jam',
	        'i' => 'menit',
	        's' => 'detik',
	    );

	    foreach ($string as $k => &$v) {
	        if ($diff->$k) {
	            $v = $diff->$k . ' ' . $v . ($diff->$k > 1 ? '' : '');
	        } else {
	            unset($string[$k]);
	        }
	    }

	    if (!$full) $string = array_slice($string, 0, 1);
	    return $string ? implode(', ', $string).' lagi' : '';

	}

	function cleanhtml($text){
		$TextTmp = preg_replace("/\t+/", "", $text);
       	$text2 = strip_tags($TextTmp);
        $text2 = html_entity_decode($text2);
        $text2 = urldecode($text2);
        $text2 = preg_replace('/[^A-Za-z0-9. -{\n}]/', ' ', $text2);
        $text2 = preg_replace('/ +/', ' ', $text2);
        $text2 = trim($text2);
        return $text2;
	}

	function countWorkingDays($startDate, $endDate, $publicHolidays = array()) {
		$start = new DateTime($startDate);
		$end = new DateTime($endDate);
		$interval = new DateInterval('P1D'); // Interval per hari
		$period = new DatePeriod($start, $interval, $end);
	
		$workingDays = 0;
		foreach ($period as $date) {
			$dayOfWeek = $date->format('N'); // Mendapatkan hari dalam format ISO-8601 (1 untuk Senin, 7 untuk Minggu)
			if ($dayOfWeek < 6 && !in_array($date->format('Y-m-d'), $publicHolidays)) {
				$workingDays++;
			}
		}
	
		return $workingDays;
	}
	

}