<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class M_monev_sakip extends CI_Model
{   
    public function __construct(){
        parent::__construct();
        $this->db2 = $this->load->database('evakip', TRUE);
        //table yang kurang 
        //1.perkaradiversiweb
        //2.perkaramediasiweb
    }

    var $table = 'eksekusiweb';

    private function _get_datatables_query(){
        $jenis_laporan = $this->encryption->decrypt(base64_decode($this->uri->segment(4)));

        $start_year = $this->uri->segment(5);
        $start_month = $this->uri->segment(6);
        $end_year = $this->uri->segment(7);
        $end_month = $this->uri->segment(8);

        $date_start = $start_year.'-'.$start_month;
        $date_end = $end_year.'-'.$end_month;

        $arrPenyelesaianPerkara = array('1','1.1','1.2','1.3','2','2.1','2.2','2.3','21','21.1','21.2','21.3','22','22.1','22.2','22.3');
        if(in_array($jenis_laporan,$arrPenyelesaianPerkara))
        {

            $cHoliday = $this->getHolidaydays($date_start,$date_end);
            $libursabtuminggu = $this->getHolidaydays($date_start,$date_end);
            // echo $this->getHolidaydays($date_start,$date_end);


            $this->db->select(' b.nama as nama_alur, a.tglPendaftaran, a.jenisPerkara, a.noPerkara, a.statusAkhir, a.tglPutusan, a.tglMinutasi , c.tglPenetapan, c.tglLaporan, TIMESTAMPDIFF(DAY, d.tglPenetapan,c.tglLaporan) as proses_mediasi, 
                    IF(a.klasifikasiPerkara IN (1,7),
                            IF(c.jenisHasilMediasi IS NULL,
                                DATEDIFF(a.tglPutusan,a.tglPendaftaran),
                                    DATEDIFF(d.tglPenetapan,a.tglPendaftaran) + DATEDIFF(a.tglPutusan,c.tglLaporan)),
                            DATEDIFF(a.tglPutusan,a.tglPendaftaran)	
                        ) AS lamaproses');
            if($jenis_laporan=='21'){
                // $this->db->select(' a.tgl');
            }
            $this->db->from('dataumumweb a');
            $this->db->join('alurperkaraweb b','a.klasifikasiPerkara = b.id','left');
            $this->db->join('mediasiweb c','a.IDPerkara=c.IDPerkara','left');
            $this->db->join('sidangpertamaweb d','a.IDPerkara=d.IDPerkara','left');
            $this->db->where(" (LEFT(a.tglPutusan, 7) >= '".$date_start."' AND LEFT(a.tglPutusan, 7) <= '".$date_end."') ");
            $this->db->order_by('a.tglPutusan','DESC');
            

            $arrAllPerkara = array('1.1','2.1');
            if(in_array($jenis_laporan,$arrAllPerkara))
            {
                if($jenis_laporan=='1.1')
                {
                    $this->db->where(" a.klasifikasiPerkara in ('1','2','3','4','5','7','8','18') ");
                }elseif($jenis_laporan=='2.1')
                {
                    $this->db->where(" a.klasifikasiPerkara in (111,112,113,118,119)  ");
                }
            }

            $arrAllPerkaraPHI = array('21.1','22.1');
            if(in_array($jenis_laporan,$arrAllPerkaraPHI))
            {
                if($jenis_laporan == '21.1'){
                    $this->db->where(" a.klasifikasiPerkara = '6' ");
                }elseif($jenis_laporan=='22.1'){
                    $this->db->where(" a.klasifikasiPerkara = '115'  ");
                }
            }


            $arrTepatWaktuPidana = array('1','1.2');
            if(in_array($jenis_laporan,$arrTepatWaktuPidana))
            {
                $this->getIsMediasi($operator = "<=");
                $this->db->where(" a.klasifikasiPerkara in ('1','2','3','4','5','7','8','18')  ");
            }

            $arrTepatWaktuPerdata = array('2','2.2');
            if(in_array($jenis_laporan,$arrTepatWaktuPerdata))
            {
                $this->db->where(" TIMESTAMPDIFF(MONTH, a.tglPendaftaran,a.tglPutusan) <= 5 ");
                $this->db->where(" a.klasifikasiPerkara in (111,112,113,118,119) ");
            }

            $arrTepatWaktuPHI = array('21','21.2');
            if(in_array($jenis_laporan,$arrTepatWaktuPHI))
            {
                $this->db->where(" TIMESTAMPDIFF(MONTH, a.tglPendaftaran,a.tglPutusan) <= 5 ");
                $this->db->where(" a.klasifikasiPerkara  = '6'   ");
            }

            $arrTepatWaktuTpk = array('22','22.2');
            if(in_array($jenis_laporan,$arrTepatWaktuTpk))
            {
                $this->db->where(" TIMESTAMPDIFF(MONTH, a.tglPendaftaran,a.tglPutusan) <= 5 ");
                $this->db->where(" a.klasifikasiPerkara  = '115'   ");
            }

            $arrTerlambatPidana = array('1.3');
            if(in_array($jenis_laporan,$arrTerlambatPidana))
            {
                $this->getIsMediasi($operator = ">");
                $this->db->where(" a.klasifikasiPerkara in ('1','2','3','4','5','7','8','18') ");
            }

            $arrTerlambatPerdata = array('2.3');
            if(in_array($jenis_laporan,$arrTerlambatPerdata))
            {
                $this->db->where(" TIMESTAMPDIFF(MONTH, a.tglPendaftaran,a.tglPutusan) > 5 ");
                $this->db->where(" a.klasifikasiPerkara in (111,112,113,118,119)  ");
            }
            
            $arrTerlambatPHI = array('21.3');
            if(in_array($jenis_laporan,$arrTerlambatPHI))
            {
                $this->db->where(" TIMESTAMPDIFF(MONTH, a.tglPendaftaran,a.tglPutusan) > 5 ");
                $this->db->where(" a.klasifikasiPerkara = '6' ");
            }

            $arrTerlambatTpk = array('22.3');
            if(in_array($jenis_laporan,$arrTerlambatTpk))
            {
                $this->db->where(" TIMESTAMPDIFF(MONTH, a.tglPendaftaran,a.tglPutusan) > 5 ");
                $this->db->where(" a.klasifikasiPerkara = '115' ");
            }

            if($_POST['search']['value']){
                $this->db->group_start();
                $this->db->or_like('b.nama', $_POST['search']['value']);
                $this->db->or_like('a.jenisPerkara', $_POST['search']['value']);
                $this->db->or_like('a.noPerkara', $_POST['search']['value']);
                $this->db->or_like('a.statusAkhir', $_POST['search']['value']);          
                $this->db->group_end();     
            }
        }


        $arrTrx = array('3','3.1','3.2','3.3');
        if(in_array($jenis_laporan,$arrTrx))
        {
            $this->db2->select(' a.* ');
            $this->db2->from('trx_laporan a');
            $this->db2->where(" left(a.thn_bln_laporan,7) >= '".$date_start."' AND left(a.thn_bln_laporan,7) <= '".$date_end."' ");
            $arrRJ = array('3','3.1','3.2','3.3');
            if(in_array($jenis_laporan,$arrRJ))
            {
                $this->db2->where(" a.jenis_laporan ='3' ");
            }
        }

        $arrJLBanding = array('4','4.1','4.2','4.3');
        if(in_array($jenis_laporan,$arrJLBanding))
        {
            $this->db->select(' b.nama as nama_alur, a.tglPendaftaran, a.jenisPerkara, a.noPerkara, a.statusAkhir, a.tglPutusan, a.tglMinutasi,c.tglPermohonanBanding,c.noPerkarabanding ');
            $this->db->from('dataumumweb a');
            $this->db->join('alurperkaraweb b','a.klasifikasiPerkara = b.id','left');
            $this->db->join('bandingweb c','a.IDPerkara = c.IDPerkara','left');
            $this->db->where(" (LEFT(a.tglPutusan, 7) >= '".$date_start."' AND LEFT(a.tglPutusan, 7) <= '".$date_end."') ");
            $this->db->order_by('a.tglPutusan','DESC');

            if($jenis_laporan=='4' || $jenis_laporan=='4.2')
            {
                $this->db->where(" a.klasifikasiPerkara IN (1,7,111,113,115,118)  ");
                $this->db->where(" c.tglPermohonanBanding IS NULL  ");
            }

            if($jenis_laporan=='4.1')
            {
                $this->db->where(" a.klasifikasiPerkara IN (1,7,111,113,115,118)  ");
            }

            if($jenis_laporan=='4.3')
            {
                $this->db->where(" a.klasifikasiPerkara IN (1,7,111,113,115,118)  ");
                $this->db->where(" c.tglPermohonanBanding IS NOT NULL AND (LEFT(c.tglPermohonanBanding, 7) >= '".$date_start."' AND LEFT(c.tglPermohonanBanding, 7) <= '".$date_end."') ");
            }

            if($_POST['search']['value']){
                $this->db->group_start();
                $this->db->or_like('b.nama', $_POST['search']['value']);
                $this->db->or_like('a.jenisPerkara', $_POST['search']['value']);
                $this->db->or_like('a.noPerkara', $_POST['search']['value']);
                $this->db->or_like('a.statusAkhir', $_POST['search']['value']);         
                $this->db->group_end();     
            }
        }

        $arrJLKasasi = array('5','5.1','5.2','5.3');
        if(in_array($jenis_laporan,$arrJLKasasi))
        {
            $this->db->select(' b.nama as nama_alur, a.tglPendaftaran, a.jenisPerkara, a.noPerkara, a.statusAkhir, a.tglPutusan, a.tglMinutasi, c.tglPermohonanKasasi  ');
            $this->db->from('dataumumweb a');
            $this->db->join('alurperkaraweb b','a.klasifikasiPerkara = b.id','left');
            // $this->db->join('bandingweb c','a.IDPerkara = c.IDPerkara','left');
            $this->db->join('kasasiweb c','a.IDPerkara = c.IDPerkara','left');
            $this->db->join("(SELECT IDPerkara,IDStatusPutusan,statusPutusan FROM perkaraputusanterdakwaweb WHERE IDStatusPutusan = '20' 
                             AND (LEFT(tglPutusan, 7) >= '".$date_start."' AND LEFT(tglPutusan, 7) <= '".$date_end."') 
                             GROUP BY IDPerkara) d ","a.IDPerkara = d.IDPerkara","left");
            $this->db->where(" (a.klasifikasiPerkara IN (2,3,4,6) OR (a.klasifikasiPerkara = '111' AND d.IDStatusPutusan IS NOT NULL)) ");
            $this->db->order_by('a.tglPutusan','DESC');

            if($jenis_laporan=='5' || $jenis_laporan=='5.3')
            {
                $this->db->where(" c.tglPermohonankasasi IS NOT NULL ");
                $this->db->where(" (LEFT(a.tglPutusan, 7) >= '".$date_start."' AND LEFT(a.tglPutusan, 7) <= '".$date_end."') ");
            }

            if($jenis_laporan=='5.1')
            {
                $this->db->where(" (LEFT(a.tglPutusan, 7) >= '".$date_start."' AND LEFT(a.tglPutusan, 7) <= '".$date_end."') ");
            }

            if($jenis_laporan=='5.2')
            {
                $this->db->where(" c.tglPermohonankasasi is null ");
                $this->db->where(" (LEFT(a.tglPutusan, 7) >= '".$date_start."' AND LEFT(a.tglPutusan, 7) <= '".$date_end."') ");
            }

            if($_POST['search']['value']){
                $this->db->group_start();
                $this->db->or_like('b.nama', $_POST['search']['value']);
                $this->db->or_like('a.jenisPerkara', $_POST['search']['value']);
                $this->db->or_like('a.noPerkara', $_POST['search']['value']);
                $this->db->or_like('a.statusAkhir', $_POST['search']['value']);         
                $this->db->group_end();     
            }
        }

        $arrJLDIversi = array('6','6.1','6.2','6.3');
        if(in_array($jenis_laporan,$arrJLDIversi))
        {
        // x.1 : Jumlah Pidsus Anak
        // x.2 : jumlah Jumlah Diversi Berhasil
        // x.3 : jumlah Diversi Tidak berhasil

            $this->db->select(' b.nama as nama_alur, a.tglPendaftaran, a.jenisPerkara, a.noPerkara, a.statusAkhir, a.tglPutusan, a.tglMinutasi,c.tgl_musyawarah, c.hasil_diversi,  c.kesepakatan_melaksanakan_diversi, c.tgl_laporan_hakim,c.tgl_pelaksanaan_isi_diversi ');
            $this->db->from('dataumumweb a');
            $this->db->join('alurperkaraweb b','a.klasifikasiPerkara = b.id','left');
            $this->db->join('diversiweb c','a.IDPerkara=c.perkara_id','left');
            $this->db->order_by('a.tglPutusan','DESC');

            if($jenis_laporan=='6' || $jenis_laporan=='6.2')
            {
                $this->db->where(" (LEFT(a.tglPendaftaran, 7) >= '".$date_start."' AND LEFT(a.tglPendaftaran, 7) <= '".$date_end."') AND a.klasifikasiPerkara = '118' ");
                $this->db->where(" c.hasil_diversi = 'Berhasil' ");
            }

            if($jenis_laporan=='6.1')
            {
                $this->db->where(" (LEFT(a.tglPendaftaran, 7) >= '".$date_start."' AND LEFT(a.tglPendaftaran, 7) <= '".$date_end."') AND a.klasifikasiPerkara = '118' ");
            }

            if($jenis_laporan=='6.3')
            {
                $this->db->where(" (LEFT(a.tglPendaftaran, 7) >= '".$date_start."' AND LEFT(a.tglPendaftaran, 7) <= '".$date_end."') AND a.klasifikasiPerkara = '118' ");
                $this->db->where(" (c.hasil_diversi = 'Tidak Berhasil' OR c.perkara_id is null ) ");
            }
        }

        $arrIKM = array('7','7.1','7.2','7.3');
        if(in_array($jenis_laporan,$arrIKM))
        {
            $this->db2->select(' a.* ');
            $this->db2->from('trx_laporan a');
            $this->db2->where(" left(a.thn_bln_laporan,7) >= '".$date_start."' AND left(a.thn_bln_laporan,7) <= '".$date_end."' ");
            $this->db2->where(" a.jenis_laporan ='7' ");
        }

        $arrJLTepatWaktu = array('8','8.1','8.2','8.3','9','9.1','9.2','9.3');
        if(in_array($jenis_laporan,$arrJLTepatWaktu))
        {
            // 8 : perdata
            // 8.1 : Jumlah Putusan All
            // 8.2 : jumlah Tepat Waktu
            // 8.3 : jumlah Tidak Tepat Waktu

            $arrPerdata = array('8','8.1','8.2','8.3');
            if(in_array($jenis_laporan,$arrPerdata))
            {
                $qColSel = "tglPemberitahuan ";
            }

            $arrPidana = array('9','9.1','9.2','9.3');
            if(in_array($jenis_laporan,$arrPidana))
            {
                $qColSel = "tglKirimSalinan ";
            }

            $this->db->select(' b.nama as nama_alur, a.tglPendaftaran, a.jenisPerkara, a.noPerkara, a.statusAkhir, a.tglPutusan, a.tglMinutasi,c.jarakpengiriman,c.pihak,c.justlate as pihak_terlambat, c.'.$qColSel.' ');
            $this->db->from('dataumumweb a');
            $this->db->join('alurperkaraweb b','a.klasifikasiPerkara = b.id','left');
            $this->db->join(" (SELECT 
                                    b.".$qColSel ." ,
                                    MAX(TIMESTAMPDIFF(DAY,a.tglPutusan, b.".$qColSel .")) AS jarakpengiriman,
                                    b.IDPerkara ,
                                    GROUP_CONCAT(b.nama,' : <b>',TIMESTAMPDIFF(DAY,a.tglPutusan, b.".$qColSel ."), '</b> Hari;' SEPARATOR '</br>') AS pihak,
                                    IF(MAX(TIMESTAMPDIFF(DAY,a.tglPutusan, b.".$qColSel .")) > 14 , GROUP_CONCAT(b.nama,' : ',TIMESTAMPDIFF(DAY,a.tglPutusan, b.".$qColSel ."),' Hari' SEPARATOR '</br>'), '') AS justlate 
                                FROM
                                    dataumumweb a 
                                    LEFT JOIN putusanpemberitahuanweb b 
                                    ON a.IDPerkara = b.IDPerkara 
                                WHERE (LEFT(a.tglPutusan, 7) >= '".$date_start."' AND LEFT(a.tglPutusan, 7) <= '".$date_end."')
                                GROUP BY b.IDPerkara) c ","a.IDPerkara = c.IDPerkara","left");
            $this->db->where(" (LEFT(a.tglPutusan, 7) >= '".$date_start."' AND LEFT(a.tglPutusan, 7) <= '".$date_end."') ");

            $arrTWPerdata = array('8','8.2');
            if(in_array($jenis_laporan,$arrTWPerdata))
            {
                $this->db->where(" a.klasifikasiPerkara <= '50' ");
                $this->db->where(" c.jarakpengiriman <= '14' ");
            }

            if($jenis_laporan=='8.3')
            {
                $this->db->where(" a.klasifikasiPerkara <= '50' ");
                $this->db->where(" c.jarakpengiriman > '14' ");
            }

            if($jenis_laporan=='8.1')
            {
                $this->db->where(" a.klasifikasiPerkara <= '50' ");
                $this->db->where(" c.tglPemberitahuan IS NOT NULL ");
            }

            $arrTWPidana = array('9','9.2');
            if(in_array($jenis_laporan,$arrTWPidana))
            {
                $this->db->where(" a.klasifikasiPerkara IN (111,112,113,118) ");
                $this->db->where(" c.jarakpengiriman <= '14' ");
            }

            if($jenis_laporan=='9.3')
            {
                $this->db->where(" a.klasifikasiPerkara IN (111,112,113,118) ");
                $this->db->where(" c.jarakpengiriman > '14' ");
            }

            if($jenis_laporan=='9.1')
            {
                $this->db->where(" a.klasifikasiPerkara IN (111,112,113,118) ");
                $this->db->where(" c.tglKirimSalinan IS NOT NULL ");
            }

            if($_POST['search']['value']){
                $this->db->group_start();
                $this->db->or_like('b.nama', $_POST['search']['value']);
                $this->db->or_like('a.jenisPerkara', $_POST['search']['value']);
                $this->db->or_like('a.noPerkara', $_POST['search']['value']);
                $this->db->or_like('a.statusAkhir', $_POST['search']['value']);         
                $this->db->group_end();     
            }

        }

        $arrMediasi = array('10','10.1','10.2','10.3');
        if(in_array($jenis_laporan,$arrMediasi))
        {
            $this->db->select(' b.nama as nama_alur, a.tglPendaftaran, a.jenisPerkara, a.noPerkara, a.statusAkhir, a.tglPutusan, a.tglMinutasi,c.tglPutusan,c.jenisHasilMediasi as hasil_mediasi,c.hasil as hasil_mediasi_text,c.tglLaporan ');
            $this->db->from('dataumumweb a');
            $this->db->join('alurperkaraweb b','a.klasifikasiPerkara = b.id','left');
            $this->db->join('mediasiweb c','a.IDPerkara=c.IDPerkara','left');
            $this->db->where(" (LEFT(a.tglPendaftaran, 7) >= '".$date_start."' AND LEFT(a.tglPendaftaran, 7) <= '".$date_end."') ");
            $this->db->where(" a.klasifikasiPerkara = '1' ");
            $this->db->order_by('a.tglPendaftaran','DESC');  

            if($jenis_laporan=='10' || $jenis_laporan=='10.2')
            {
                $this->db->where(" (c.jenisHasilMediasi = 'Y' OR c.jenisHasilMediasi = 'Y1' OR c.jenisHasilMediasi = 'Y2'  OR c.jenisHasilMediasi = 'D' OR c.jenisHasilMediasi = 'S') ");
            }

            if($jenis_laporan=='10.3')
            {
                $this->db->where(" (c.jenisHasilMediasi = 'T' OR c.jenisHasilMediasi IS NULL) ");
            }

            if($jenis_laporan=='10.1')
            {}

            if($_POST['search']['value']){
                $this->db->group_start();
                $this->db->or_like('b.nama', $_POST['search']['value']);
                $this->db->or_like('a.jenisPerkara', $_POST['search']['value']);
                $this->db->or_like('a.noPerkara', $_POST['search']['value']);
                $this->db->or_like('a.statusAkhir', $_POST['search']['value']);         
                $this->db->group_end();     
            }
        }

        $arrProdeo = array('11','11.1','11.2','11.3');
        if(in_array($jenis_laporan,$arrProdeo))
        {
            $this->db->select(' b.nama as nama_alur, a.tglPendaftaran, a.jenisPerkara, a.noPerkara, a.statusAkhir, a.tglPutusan, a.tglMinutasi,a.prodeo ');
            $this->db->from('dataumumweb a');
            $this->db->join('alurperkaraweb b','a.klasifikasiPerkara = b.id','left');
            $this->db->where(" (LEFT(a.tglPutusan, 7) >= '".$date_start."' AND LEFT(a.tglPutusan, 7) <= '".$date_end."') ");
            $this->db->where(" a.klasifikasiPerkara < 100 ");
            $this->db->where(" a.prodeo = '1' ");
            $this->db->order_by('a.tglPendaftaran','DESC');  

            if($_POST['search']['value']){
                $this->db->group_start();
                $this->db->or_like('b.nama', $_POST['search']['value']);
                $this->db->or_like('a.jenisPerkara', $_POST['search']['value']);
                $this->db->or_like('a.noPerkara', $_POST['search']['value']);
                $this->db->or_like('a.statusAkhir', $_POST['search']['value']);         
                $this->db->group_end();     
            }
        }

        $arrSikel = array('12','12.1','12.2','12.3');
        if(in_array($jenis_laporan,$arrSikel))
        {
            $this->db->select(' b.nama as nama_alur, a.tglPendaftaran, a.jenisPerkara, a.noPerkara, a.statusAkhir, a.tglPutusan, a.tglMinutasi,a.prodeo, c.countSikel');
            $this->db->from('dataumumweb a');
            $this->db->join('alurperkaraweb b','a.klasifikasiPerkara = b.id','left');
            $this->db->join('   (SELECT DISTINCT(IDPerkara) AS idPerkara , count(ID) AS countSikel, sidangKeliling
                                FROM jadwalsidangweb WHERE sidangKeliling ="Y" 
                                GROUP BY IDPerkara) c','a.IDPerkara = c.idPerkara','left');
            $this->db->where(" (LEFT(a.tglPendaftaran, 7) >= '".$date_start."' AND LEFT(a.tglPendaftaran, 7) <= '".$date_end."') ");
            // $this->db->where(" a.klasifikasiPerkara < 100 ");
            $this->db->where(" c.sidangKeliling = 'Y' ");
            $this->db->order_by('a.tglPendaftaran','DESC');  

            if($_POST['search']['value']){
                $this->db->group_start();
                $this->db->or_like('b.nama', $_POST['search']['value']);
                $this->db->or_like('a.jenisPerkara', $_POST['search']['value']);
                $this->db->or_like('a.noPerkara', $_POST['search']['value']);
                $this->db->or_like('a.statusAkhir', $_POST['search']['value']);         
                $this->db->group_end();     
            }
        }

        $arrTrx = array('13','13.1','13.2','13.3');
        if(in_array($jenis_laporan,$arrTrx))
        {
            $this->db2->select(' a.* ');
            $this->db2->from('trx_laporan a');
            $this->db2->where(" left(a.thn_bln_laporan,7) >= '".$date_start."' AND left(a.thn_bln_laporan,7) <= '".$date_end."' ");
            $arrPbk = array('13','13.1','13.2','13.3');
            if(in_array($jenis_laporan,$arrPbk))
            {
                $this->db2->where(" a.jenis_laporan ='13' ");
            }
        }


        $arrEksekusi = array('14','14.1','14.2','14.3');
        if(in_array($jenis_laporan,$arrEksekusi))
        {
            $this->db->select(' a.* ');
            $this->db->from('eksekusiweb a');
            $this->db->where(" (LEFT(a.permohonanEsekusi, 7) >= '".$date_start."' AND LEFT(a.permohonanEsekusi, 7) <= '".$date_end."') ");
            $this->db->order_by('a.permohonanEsekusi','DESC');  

            if($jenis_laporan=='14' || $jenis_laporan=='14.2')
            {
                $this->db->where(" ((penetapanTeguranEksekusi IS NOT NULL OR penetapanTeguranEksekusi <> '0000-00-00') OR 
                                (pelaksanaanTeguranEksekusi IS NOT NULL OR pelaksanaanTeguranEksekusi <> '0000-00-00') OR 
                                (penetapanSitaEksekusi IS NOT NULL OR penetapanSitaEksekusi <> '0000-00-00') OR
                                (pelaksanaanEksekusiLelang IS NOT NULL OR pelaksanaanEksekusiLelang <> '0000-00-00')) ");
            }

            if($jenis_laporan=='14.3')
            {
                $this->db->where(" ((penetapanTeguranEksekusi IS NULL OR penetapanTeguranEksekusi = '0000-00-00') OR 
                                    (pelaksanaanTeguranEksekusi IS NULL OR pelaksanaanTeguranEksekusi = '0000-00-00') OR 
                                    (penetapanSitaEksekusi IS NULL OR penetapanSitaEksekusi = '0000-00-00') OR
                                    (pelaksanaanEksekusiLelang IS NULL OR pelaksanaanEksekusiLelang = '0000-00-00')) ");
                $this->db->where(" a.permohonanEsekusi IS NULL ");
            }

            if($jenis_laporan=='14.1')
            {
                $this->db->where(" a.permohonanEsekusi IS NOT NULL ");
            }
        }
    }

    public function get_datatables($jenis_laporan){
        $this->_get_datatables_query();
        if($_POST['length'] != -1)
        $arrTrx = array('3','3.1','3.2','3.3','7','7.1','7.2','7.3','13','13.1','13.2','13.3');
        if(in_array($jenis_laporan,$arrTrx))
        {
            $this->db2->limit($_POST['length'], $_POST['start']);
            $query = $this->db2->get();
        }else
        {
            $this->db->limit($_POST['length'], $_POST['start']);
            $query = $this->db->get();
        }
        return $query->result();
    }

    public function count_filtered($jenis_laporan){
        $this->_get_datatables_query();
        // $query = $this->db->get();
        $arrTrx = array('3','3.1','3.2','3.3','7','7.1','7.2','7.3','13','13.1','13.2','13.3');
        if(in_array($jenis_laporan,$arrTrx))
        {
            $query = $this->db2->get();
        }else
        {
            $query = $this->db->get();
        }
        return $query->num_rows();
    }

    public function count_all(){
        $this->db->from($this->table);
        return $this->db->count_all_results();
    }

    private function getIsMediasi($operator){
        $this->db->where(" (IF(a.klasifikasiPerkara IN (1,7),
                                        IF(c.jenisHasilMediasi IS NULL,
                                            DATEDIFF(a.tglPutusan,a.tglPendaftaran),
                                                DATEDIFF(d.tglPenetapan,a.tglPendaftaran) + DATEDIFF(a.tglPutusan,c.tglLaporan)),
                                        DATEDIFF(a.tglPutusan,a.tglPendaftaran)	
                                    ))/30 $operator 5 ");
    }

    private function getHolidaydays($start,$end){
        try {
            $query = $this->db->query("SELECT 
                                            COUNT(*) AS hariLibur
                                        FROM
                                            (
                                                SELECT 
                                                    DATE_ADD('$start-01', INTERVAL t.i DAY) AS DATE
                                                FROM
                                                    (SELECT 
                                                        (t4.i * 256 + t3.i * 64 + t2.i * 16 + t1.i * 4 + t0.i) AS i
                                                    FROM
                                                        (SELECT 0 AS i UNION SELECT 1 UNION SELECT 2 UNION SELECT 3) AS t0
                                                    CROSS JOIN (SELECT 0 AS i UNION SELECT 1 UNION SELECT 2 UNION SELECT 3) AS t1
                                                    CROSS JOIN (SELECT 0 AS i UNION SELECT 1 UNION SELECT 2 UNION SELECT 3) AS t2
                                                    CROSS JOIN (SELECT 0 AS i UNION SELECT 1 UNION SELECT 2 UNION SELECT 3) AS t3
                                                    CROSS JOIN (SELECT 0 AS i UNION SELECT 1 UNION SELECT 2 UNION SELECT 3) AS t4
                                                    ) AS t
                                                WHERE
                                                    DATE_ADD('$start-01', INTERVAL t.i DAY) BETWEEN '$start-01' AND '$end-31'
                                                    AND WEEKDAY(DATE_ADD('$start-01', INTERVAL t.i DAY)) >= 5 -- mengambil akhir pekan (Sabtu dan Minggu)
                                            ) AS holiday_days;");
            return $query->row()->hariLibur;
        } catch (Exception $e) {
            return FALSE;
        }

    }

    function getAlur($alur_perkara_id){
        
        try {
            $query = $this->db2->query(" select a.* ,b.nama
                                        from alur_perkara_detil a
                                        left join alur_perkara b on a.`alur_perkara_banding_id` = b.id
                                        where a.alur_perkara_asal_id = '".$alur_perkara_id."';");
            return $query;
        } catch (Exception $e) {
            return FALSE;
        }
    }

    function getPerkaraTepatWaktu($date_start,$date_end,$alur_perkara_id,$jenis_laporan){
        try {
            if($jenis_laporan==1){
                $query = $this->db->query(" SELECT  aa.klasifikasiPerkara,
                                                SUM(CASE WHEN aa.klasifikasiPerkara ".$alur_perkara_id." THEN 1 ELSE 0 END) AS totalperkara,
                                                SUM(CASE WHEN aa.umurperkara/30 <=5 THEN 1 ELSE 0 END) AS totaltepatwaktu,
                                                SUM(CASE WHEN aa.umurperkara/30 >5 THEN 1 ELSE 0 END) AS totaltidaktepatwaktu  
                                               
                                            FROM 
                                            (SELECT 
                                            a.klasifikasiPerkara,
                                            a.noPerkara,
                                            a.tglPendaftaran, 
                                            a.tglPutusan,
                                            c.tglMulaiMediasi,
                                            DATEDIFF(c.tglLaporan,b.tglSidangPertama) AS lamaprosesmediasi,
                                            IF(a.klasifikasiPerkara IN (1,7),
                                                IF(c.jenisHasilMediasi IS NULL,
                                                    DATEDIFF(a.tglPutusan,a.tglPendaftaran),
                                                        DATEDIFF(b.tglPenetapan,a.tglPendaftaran) + DATEDIFF(a.tglPutusan,c.tglLaporan)),
                                                    
                                                DATEDIFF(a.tglPutusan,a.tglPendaftaran)	
                                            ) AS umurperkara,
                                            b.tglPenetapan AS tglPenMediasi,b.tglSidangPertama,
                                            c.jenisHasilMediasi,
                                            c.tglLaporan
                                            FROM
                                            dataumumweb a 
                                            LEFT JOIN sidangpertamaweb b ON a.IDPerkara=b.IDPerkara
                                            LEFT JOIN mediasiweb c ON a.IDPerkara=c.IDPerkara
                                            WHERE
                                            (LEFT(a.tglPutusan, 7) >= '".$date_start."' AND LEFT(a.tglPutusan, 7) <= '".$date_end."') 
                                            AND a.klasifikasiPerkara ".$alur_perkara_id.") aa  ;");
            }else{
                $query = $this->db->query(" SELECT klasifikasiPerkara,
                                            SUM(CASE
                                            WHEN klasifikasiPerkara ".$alur_perkara_id." THEN 1
                                            ELSE 0 END) AS totalperkara,
                                            SUM(CASE
                                            WHEN TIMESTAMPDIFF(MONTH, tglPendaftaran,tglPutusan) <=5 THEN 1
                                            ELSE 0 END) AS totaltepatwaktu,
                                            SUM(CASE
                                            WHEN TIMESTAMPDIFF(MONTH, tglPendaftaran,tglPutusan) >5 THEN 1
                                            ELSE 0 END) AS totaltidaktepatwaktu  
                                            FROM 
                                            dataumumweb 
                                            WHERE 
                                            (LEFT(tglPutusan,7) >= '".$date_start."' AND LEFT(tglPutusan,7) <= '".$date_end."')
                                            AND klasifikasiPerkara ".$alur_perkara_id." ");
            }

            

            
            return $query;
        } catch (Exception $e) {
            return FALSE;
        }
    }

    function getPerkaraTepatWaktuByAlur($date_start,$date_end,$alur_perkara_id){
        try {
            $query = $this->db->query(" SELECT b.id AS idalur_perkara,b.nama AS namaalur,
                                        SUM(CASE
                                        WHEN a.klasifikasiPerkara ".$alur_perkara_id."  THEN 1
                                        ELSE 0 END) AS jumlahperkaraperdata,
                                        SUM(CASE
                                        WHEN TIMESTAMPDIFF(MONTH, a.tglPendaftaran,tglPutusan) <=5 THEN 1
                                        ELSE 0 END) AS totaltepatwaktu,
                                        SUM(CASE
                                        WHEN TIMESTAMPDIFF(MONTH, a.tglPendaftaran,tglPutusan) >5 THEN 1
                                        ELSE 0 END) AS totaltidaktepatwaktu  
                                        FROM 
                                        dataumumweb a
                                        LEFT JOIN alurperkaraweb b ON a.klasifikasiPerkara = b.id
                                        WHERE 
                                        (LEFT(tglPutusan,7) >= '".$date_start."' AND LEFT(tglPutusan,7) <= '".$date_end."')
                                        AND a.klasifikasiPerkara  ".$alur_perkara_id."
                                        GROUP BY a.klasifikasiPerkara;");
            return $query;
        } catch (Exception $e) {
            return FALSE;
        }
    }

    function getRJ($date_start,$date_end,$jenis_laporan){
        try {
            $query = $this->db2->query("SELECT SUM(pembilang) AS totalputusrj, SUM(penyebut) AS totalpermohonanrj
                                        FROM trx_laporan
                                        WHERE LEFT(thn_bln_laporan,7) >='".$date_start."' AND  LEFT(thn_bln_laporan,7) <='".$date_end."'
                                        AND jenis_laporan ='3' ");
            return $query;
        } catch (Exception $e) {
            return FALSE;
        }
    }

    function getPersepsiIKM($date_start,$date_end,$jenis_laporan){
        try {
            $query = $this->db2->query("SELECT   SUM(pembilang) AS totalPembilang, SUM(penyebut) AS totalPenyebut, COUNT(*) AS totalRecord 
                                        FROM trx_laporan
                                        WHERE LEFT(thn_bln_laporan,7) >='".$date_start."' AND  LEFT(thn_bln_laporan,7) <='".$date_end."'
                                        AND jenis_laporan='".$jenis_laporan."' ");
            return $query;
        } catch (Exception $e) {
            return FALSE;
        }
    }

    function getTidakBanding($date_start,$date_end,$alur_perkara_id){
        try {
            $query = $this->db->query(" SELECT 
                                        SUM(CASE WHEN a.tglPutusan IS NOT NULL THEN 1 ELSE 0 END) AS totalperkara,
                                        SUM(CASE WHEN b.tglPermohonanBanding IS NOT NULL AND (LEFT(b.tglPermohonanBanding, 7) >= '".$date_start."' AND LEFT(b.tglPermohonanBanding, 7) <= '".$date_end."') THEN 1 ELSE 0 END) AS banding,
                                        SUM(CASE WHEN b.tglPermohonanBanding IS NULL THEN 1 ELSE 0 END) AS tdk_banding
                                        FROM 
                                        dataumumweb a
                                        LEFT JOIN bandingweb b ON a.IDPerkara=b.IDPerkara
                                        WHERE 
                                        (LEFT(a.tglPutusan, 7) >= '".$date_start."' AND LEFT(a.tglPutusan, 7) <= '".$date_end."') 
                                        AND a.klasifikasiPerkara IN (1,7,111,113,115,118);");
            return $query;
        } catch (Exception $e) {
            return FALSE;
        }
    }

    function getTidakKasasi($date_start,$date_end,$alur_perkara_id){
        try {
            $query = $this->db->query("SELECT 
                                        SUM(CASE WHEN a.IDPerkara IS NOT NULL THEN 1 ELSE 0 END) AS totalperkara,
                                        SUM(CASE WHEN c.tglPermohonankasasi IS NOT NULL THEN 1 ELSE 0 END) AS kasasi,
                                        SUM(CASE WHEN c.tglPermohonankasasi IS NULL THEN 1 ELSE 0 END) AS tidak_kasasi
                                        FROM 
                                        dataumumweb a
                                        LEFT JOIN kasasiweb c ON a.IDPerkara=c.IDPerkara
                                        LEFT JOIN (SELECT IDPerkara,IDStatusPutusan,statusPutusan FROM perkaraputusanterdakwaweb WHERE IDStatusPutusan = '20' 
                                        AND  (LEFT(tglPutusan, 7) >= '".$date_start."' AND LEFT(tglPutusan, 7) <= '".$date_end."') 
                                        GROUP BY IDPerkara) d 
                                        ON a.IDPerkara=d.IDPerkara
                                        WHERE 
                                        (LEFT(a.tglPutusan, 7) >= '".$date_start."' AND LEFT(a.tglPutusan, 7) <= '".$date_end."') 
                                        AND (a.klasifikasiPerkara IN (2,3,4,6) OR (a.klasifikasiPerkara = '111' AND d.IDStatusPutusan IS NOT NULL));");
            return $query;
        } catch (Exception $e) {
            return FALSE;
        }
    }

    function getDiversi($date_start,$date_end,$alur_perkara_id){
        try {
            $query = $this->db->query(" SELECT 
                                        SUM(CASE WHEN a.klasifikasiPerkara = '118' THEN 1 ELSE 0 END) AS perkarapidanaanak,
                                        SUM(CASE WHEN b.tgl_musyawarah IS NOT NULL THEN 1 ELSE 0 END) AS tglmusyawarah,
                                        SUM(CASE WHEN b.hasil_diversi = 'Berhasil' THEN 1 ELSE 0 END) AS diversiberhasil,
                                        SUM(CASE WHEN b.hasil_diversi = 'Tidak Berhasil' THEN 1 ELSE 0 END) AS diversigagal
                                        FROM 
                                        dataumumweb a
                                        LEFT JOIN diversiweb b ON a.IDPerkara=b.perkara_id
                                        WHERE 
                                        (LEFT(a.tglPutusan, 7) >= '".$date_start."' AND LEFT(a.tglPutusan, 7) <= '".$date_end."') 
                                        AND a.klasifikasiPerkara = '118';");
            return $query;
        } catch (Exception $e) {
            return FALSE;
        }
    }

    function getPemberitahuanPutusanPerdata($date_start,$date_end,$alur_perkara_id){
        try {
            $query = $this->db->query(" SELECT COUNT(*) AS jumlahperkara,
                                        SUM(CASE WHEN a.jarakpengiriman > '14' THEN 1 ELSE 0 END) AS as_terlambat,
                                        SUM(CASE WHEN a.jarakpengiriman <= '14' THEN 1 ELSE 0 END) AS as_tidak_terlambat
                                        FROM
                                        (SELECT 
                                        MAX(TIMESTAMPDIFF(DAY, a.tglPutusan,b.tglPemberitahuan)) AS jarakpengiriman,
                                        b.IDPerkara
                                        FROM 
                                        dataumumweb a
                                        LEFT JOIN putusanpemberitahuanweb b ON a.IDPerkara=b.IDPerkara
                                        WHERE 
                                        LEFT(a.tglPutusan, 7) >= '".$date_start."' AND LEFT(a.tglPutusan, 7) <= '".$date_end."' 
                                        AND a.klasifikasiPerkara ".$alur_perkara_id."
                                        GROUP BY b.IDPerkara) a;");
            return $query;
        } catch (Exception $e) {
            return FALSE;
        }
    }

    function getPemberitahuanPutusanPidana($date_start,$date_end,$alur_perkara_id){
        try {
            $query = $this->db->query(" SELECT COUNT(*) AS jumlahperkara,
                                        SUM(CASE WHEN a.jarakpengiriman > '14' THEN 1 ELSE 0 END) AS as_terlambat,
                                        SUM(CASE WHEN a.jarakpengiriman <= '14' THEN 1 ELSE 0 END) AS as_tidak_terlambat
                                        FROM
                                        (SELECT a.noPerkara,
                                        MAX(TIMESTAMPDIFF(DAY, a.tglPutusan,b.tglKirimSalinan)) AS jarakpengiriman,a.tglPutusan,b.tglPemberitahuan,b.tglKirimSalinan,
                                        b.IDPerkara
                                        FROM 
                                        dataumumweb a
                                        LEFT JOIN putusanpemberitahuanweb b ON a.IDPerkara=b.IDPerkara
                                        WHERE 
                                        LEFT(a.tglPutusan, 7) >= '".$date_start."' AND LEFT(a.tglPutusan, 7) <= '".$date_end."' 
                                        AND a.klasifikasiPerkara IN (111,112,113,118)
                                        GROUP BY b.IDPerkara) a;");
            return $query;
        } catch (Exception $e) {
            return FALSE;
        }
    }

    function getMediasi($date_start,$date_end,$alur_perkara_id){
        try {
            $query = $this->db->query(" SELECT 
                                        COUNT(*) AS jumlahperdata,
                                        SUM(CASE WHEN (b.jenisHasilMediasi = 'Y' OR b.jenisHasilMediasi = 'Y1' OR b.jenisHasilMediasi = 'Y2' OR b.jenisHasilMediasi = 'D' OR b.jenisHasilMediasi = 'S') THEN 1 ELSE 0 END)  AS mediasidilaksanakan
                                        FROM
                                        dataumumweb a
                                        LEFT JOIN mediasiweb b ON a.IDPerkara=b.IDPerkara
                                        WHERE 
                                        (LEFT(a.tglPendaftaran, 7) >= '".$date_start."' AND LEFT(a.tglPendaftaran, 7) <= '".$date_end."') 
                                        AND a.klasifikasiPerkara = '1';");
            return $query;
        } catch (Exception $e) {
            return FALSE;
        }
    }

    function getProdeo($date_start,$date_end,$alur_perkara_id){
        try {
            $query = $this->db->query(" SELECT 
                                        COUNT(*) AS jumlah_perkara,
                                        SUM(CASE WHEN prodeo = '1' THEN 1 ELSE 0 END) AS as_prodeo,
                                        SUM(CASE WHEN prodeo = '1' AND tglPutusan IS NOT NULL THEN 1 ELSE 0 END) AS as_putus_prodeo,
                                        SUM(CASE WHEN prodeo = '0' THEN 1 ELSE 0 END) AS as_tidak_prodeo
                                        FROM dataumumweb
                                        WHERE
                                        (LEFT(tglPutusan, 7) >= '".$date_start."' AND LEFT(tglPutusan, 7) <= '".$date_end."') 
                                        AND klasifikasiPerkara <=  '50';");
            return $query;
        } catch (Exception $e) {
            return FALSE;
        }
    }

    function getSidangKeliling($date_start,$date_end,$jenis_laporan){
        try {
            $query = $this->db2->query("SELECT SUM(pembilang) AS totalputusrj, SUM(penyebut) AS totalpermohonanrj
                                        FROM trx_laporan
                                        WHERE left(thn_bln_laporan,7) >='".$date_start."' AND  left(thn_bln_laporan,7) <='".$date_end."'
                                        AND jenis_laporan='".$jenis_laporan."' ");
            return $query;
        } catch (Exception $e) {
            return FALSE;
        }
    }

    function getPosbakum($date_start,$date_end,$jenis_laporan){
        try {
            $query = $this->db2->query("SELECT SUM(pembilang) AS totalPembilang, SUM(penyebut) AS totalPenyebut
                                        FROM trx_laporan
                                        WHERE left(thn_bln_laporan,7) >='".$date_start."' AND  left(thn_bln_laporan,7) <='".$date_end."'
                                        AND jenis_laporan='".$jenis_laporan."' ");
            return $query;
        } catch (Exception $e) {
            return FALSE;
        }
    }
    

    function getEksekusi($date_start,$date_end,$alur_perkara_id){
        try {
            $query = $this->db->query(" SELECT 
                                        SUM(CASE WHEN permohonanEsekusi IS NOT NULL THEN 1 ELSE 0 END) AS permohonaneksekusi,
                                        SUM(CASE WHEN  (
                                            (penetapanTeguranEksekusi IS NOT NULL OR penetapanTeguranEksekusi <> '0000-00-00') OR 
                                            (pelaksanaanTeguranEksekusi IS NOT NULL OR pelaksanaanTeguranEksekusi <> '0000-00-00') OR 
                                            (penetapanSitaEksekusi IS NOT NULL OR penetapanSitaEksekusi <> '0000-00-00') OR
                                            (pelaksanaanEksekusiLelang IS NOT NULL OR pelaksanaanEksekusiLelang <> '0000-00-00')
                                        )
                                        THEN 1 ELSE 0 END) AS pelaksanaaneksekusi
                                        FROM eksekusiweb
                                        WHERE 
                                        (LEFT(permohonanEsekusi, 7) >= '".$date_start."' AND LEFT(permohonanEsekusi, 7) <= '".$date_end."') ;");
            return $query;
        } catch (Exception $e) {
            return FALSE;
        }
    }


    function getTahunPerkara(){
        try {
            $query = $this->db->query("SELECT YEAR(tglPendaftaran) AS year_sel
                                        FROM dataumumweb
                                        GROUP BY YEAR(tglPendaftaran)  
                                        ORDER BY YEAR(tglPendaftaran) DESC;");
            return $query;
        } catch (Exception $e) {
            return FALSE;
        }
    }

    public function getValConfig($id){
        try {
            $query = $this->db2->query("SELECT * from sys_config where id='".$id."' ;");
            return $query;
        } catch (Exception $e) {
            return FALSE;
        }
    }

}
