<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class M_dashboard extends CI_Model
{   
    public function __construct(){
        parent::__construct();
        $this->db2 = $this->load->database('evakip', TRUE);
    }

    function getTarget($year){
        try {
            $query = $this->db2->query("SELECT * FROM trx_target WHERE tahun = '".$year."';");
            return $query;
        } catch (Exception $e) {
            return FALSE;
        }
    }

    function globalIndikator($year){
        try {
            $query = $this->db->query(" SELECT
                                        SUM(CASE
                                        WHEN a.klasifikasiPerkara in ('1','2','3','4','5','7','8','18') THEN 1
                                        ELSE 0 END) AS jumlahperkaraperdata,
                                        SUM(CASE
                                        WHEN a.klasifikasiPerkara in ('1','2','3','4','5','7','8','18') AND TIMESTAMPDIFF(MONTH, a.tglPendaftaran,a.tglPutusan) <=5 THEN 1
                                        ELSE 0 END) AS jumlahperdatatepatwaktu,
                                        SUM(CASE
                                        WHEN a.klasifikasiPerkara in ('6') THEN 1
                                        ELSE 0 END) AS jumlahperkaraperdataphi,
                                        SUM(CASE
                                        WHEN a.klasifikasiPerkara IN (6) AND TIMESTAMPDIFF(MONTH, a.tglPendaftaran,a.tglPutusan) <=5 THEN 1
                                        ELSE 0 END) AS jumlahperkaraperdataphi_tw,
                                        SUM(CASE
                                        WHEN a.klasifikasiPerkara in ('115') THEN 1
                                        ELSE 0 END) AS jumlahperkaratipikor,
                                        SUM(CASE
                                        WHEN a.klasifikasiPerkara in ('115') AND TIMESTAMPDIFF(MONTH, a.tglPendaftaran,a.tglPutusan) <=5 THEN 1
                                        ELSE 0 END) AS jumlahperkaratipikor_tw,
                                        SUM(CASE
                                        WHEN a.klasifikasiPerkara IN (111,112,113,118) THEN 1
                                        ELSE 0 END) AS jumlahperkarapidana,
                                        SUM(CASE
                                        WHEN a.klasifikasiPerkara IN (111,112,113,118) AND TIMESTAMPDIFF(MONTH, a.tglPendaftaran,a.tglPutusan) <=5 THEN 1
                                        ELSE 0 END) AS jumlahpidanatepatwaktu,
                                        SUM(CASE WHEN a.tglPutusan IS NOT NULL AND a.klasifikasiPerkara <> '114' THEN 1 ELSE 0 END) AS totalperkaraputus_q4,
                                        SUM(CASE WHEN b.tglPermohonanBanding IS NOT NULL AND a.klasifikasiPerkara <> '114' THEN 1 ELSE 0 END) AS permohonanbanding_q4,
                                        SUM(CASE WHEN a.klasifikasiPerkara = '118' THEN 1 ELSE 0 END) AS perkarapidanaanak_q6,
                                        SUM(CASE WHEN c.tgl_musyawarah IS NOT NULL THEN 1 ELSE 0 END) AS tglmusyawarah_q6,
                                        SUM(CASE WHEN c.hasil_diversi = '1' THEN 1 ELSE 0 END) AS diversiberhasil_q6,
                                        SUM(CASE WHEN c.hasil_diversi = '0' THEN 1 ELSE 0 END) AS diversigagal_q6
                                        FROM
                                        dataumumweb a
                                        LEFT JOIN bandingweb b ON a.IDPerkara=b.IDPerkara
                                        LEFT JOIN perkaradiversiweb c ON a.IDPerkara=c.perkara_id
                                        WHERE
                                        YEAR(a.tglPutusan) = '".$year."';");
            return $query;
        } catch (Exception $e) {
            return FALSE;
        }
    }

    function getRJ($year){
        try {
            $query = $this->db2->query("SELECT SUM(pembilang) AS totalputusrj, SUM(penyebut) AS totalpermohonanrj
                                        FROM trx_laporan
                                        WHERE LEFT(thn_bln_laporan,4) ='".$year."'
                                        AND jenis_laporan ='3' ");
            return $query;
        } catch (Exception $e) {
            return FALSE;
        }
    }

    function getTidakKasasi($year){
        try {
            $query = $this->db->query(" SELECT 
                                        SUM(CASE WHEN a.tglPutusan IS NOT NULL THEN 1 ELSE 0 END) AS totalperkara,
                                        SUM(CASE WHEN b.tglPermohonanBanding IS NOT NULL THEN 1 ELSE 0 END) AS banding,
                                        SUM(CASE WHEN b.tglPutusan IS NOT NULL THEN 1 ELSE 0 END) AS putusanbanding,  
                                        SUM(CASE WHEN c.tglPermohonankasasi IS NOT NULL THEN 1 ELSE 0 END) AS kasasi
                                        FROM 
                                        dataumumweb a
                                        LEFT JOIN bandingweb b ON a.IDPerkara=b.IDPerkara
                                        LEFT JOIN kasasiweb c ON b.IDPerkara=c.IDPerkara
                                        WHERE 
                                        YEAR(b.tglPutusan) = '$year'
                                        AND a.klasifikasiPerkara NOT IN (114);");
            return $query;
        } catch (Exception $e) {
            return FALSE;
        }
    }

    function getTrxLaporanIKM($year){
        try {
            $query = $this->db2->query("SELECT   
                                        SUM(CASE WHEN jenis_laporan='7' THEN 1 ELSE 0 END) AS jumlahIKM,
                                        SUM(CASE WHEN jenis_laporan='7' THEN pembilang ELSE 0 END) AS pembilangIKM,
                                        SUM(CASE WHEN jenis_laporan='7' THEN penyebut ELSE 0 END) AS penyebutIKM
                                        FROM trx_laporan
                                        WHERE (thn_bln_laporan >='".$year."-01' AND  thn_bln_laporan <='".$year."-12');");
            return $query;
        } catch (Exception $e) {
            return FALSE;
        }
    }

    
    function getPemberitahuanPerdata($year){
        try {
            $query = $this->db->query(" SELECT COUNT(*) AS jumlahperkara,
                                        SUM(CASE WHEN a.jarakpengiriman <= '14' THEN 1 ELSE 0 END) AS as_tepatwaktu
                                        FROM
                                        (SELECT 
                                        MAX(TIMESTAMPDIFF(DAY, a.tglPutusan,b.tglPemberitahuan)) AS jarakpengiriman,
                                        b.IDPerkara
                                        FROM 
                                        dataumumweb a
                                        LEFT JOIN putusanpemberitahuanweb b ON a.IDPerkara=b.IDPerkara
                                        WHERE 
                                       YEAR(a.tglPutusan) = '".$year."'
                                        AND a.klasifikasiPerkara <= '50' 
                                        AND b.tglPemberitahuan IS NOT NULL
                                        GROUP BY b.IDPerkara) a;");
            return $query;
        } catch (Exception $e) {
            return FALSE;
        }
    }

    function getPemberitahuanPidana($year){
        try {
            $query = $this->db->query(" SELECT COUNT(*) AS jumlahperkara,
                                        SUM(CASE WHEN a.jarakpengiriman <= '14' THEN 1 ELSE 0 END) AS as_tepatwaktu
                                        FROM
                                        (SELECT a.noPerkara,
                                        MAX(TIMESTAMPDIFF(DAY, a.tglPutusan,b.tglKirimSalinan)) AS jarakpengiriman,a.tglPutusan,b.tglPemberitahuan,b.tglKirimSalinan,
                                        b.IDPerkara
                                        FROM 
                                        dataumumweb a
                                        LEFT JOIN putusanpemberitahuanweb b ON a.IDPerkara=b.IDPerkara
                                        WHERE 
                                        YEAR(a.tglPutusan) = '".$year."'
                                        AND a.klasifikasiPerkara IN (111,112,113,118)
                                        AND b.tglKirimSalinan IS NOT NULL
                                        GROUP BY b.IDPerkara) a;");
            return $query;
        } catch (Exception $e) {
            return FALSE;
        }
    }

    // function getSidangKeliling($year){
    //     try {
    //         $query = $this->db2->query("SELECT SUM(pembilang) AS totalputusrj, SUM(penyebut) AS totalpermohonanrj
    //                                     FROM trx_laporan
    //                                     WHERE (thn_bln_laporan >='".$date_start."' AND  thn_bln_laporan <='".$date_end."')
    //                                     AND jenis_laporan='".$jenis_laporan."' ");
    //         return $query;
    //     } catch (Exception $e) {
    //         return FALSE;
    //     }
    // }

    function getMediasi($year){
        try {
            $query = $this->db->query(" SELECT 
                                        COUNT(*) AS jumlahperdata,
                                        SUM(CASE WHEN b.is_mediasi = '1' THEN 1 ELSE 0 END) AS berhasilmediasi
                                        FROM
                                        dataumumweb a
                                        LEFT JOIN perkaramediasiweb b ON a.IDPerkara=b.perkara_id
                                        WHERE 
                                        YEAR(a.tglPendaftaran) = '".$year."'
                                        AND a.klasifikasiPerkara = '1';");
            return $query;
        } catch (Exception $e) {
            return FALSE;
        }
    }

    function getProdeo($year){
        try {
            $query = $this->db->query(" SELECT 
                                        COUNT(*) AS jumlah_perkara,
                                        SUM(CASE WHEN prodeo = '1' THEN 1 ELSE 0 END) AS as_prodeo,
                                        SUM(CASE WHEN prodeo = '1' AND tglPutusan IS NOT NULL THEN 1 ELSE 0 END) AS as_putus_prodeo,
                                        SUM(CASE WHEN prodeo = '0' THEN 1 ELSE 0 END) AS as_tidak_prodeo
                                        FROM dataumumweb
                                        WHERE
                                        YEAR(tglPendaftaran) = '".$year."'
                                        AND klasifikasiPerkara <  '50';");
            return $query;
        } catch (Exception $e) {
            return FALSE;
        }
    }

    function getSiKel($year){
        try {
            $query = $this->db->query("SELECT 
                                            COUNT(*) AS jumlahperkara,   
                                            SUM(CASE WHEN c.sidangKeliling = 'Y' THEN 1 ELSE 0 END ) AS sikel, 
                                            SUM(CASE WHEN c.sidangKeliling = 'Y' AND a.tglPutusan IS NOT NULL THEN 1 ELSE 0 END ) AS sikel_putus 
                                        FROM 
                                        dataumumweb a
                                        LEFT JOIN 
                                        (SELECT DISTINCT(IDPerkara) AS idPerkara , COUNT(ID) AS countSikel, sidangKeliling
                                        FROM jadwalsidangweb WHERE sidangKeliling ='Y' 
                                        GROUP BY IDPerkara) c ON a.IDPerkara = c.idPerkara
                                        WHERE YEAR(a.tglPendaftaran) = '".$year."';");
            return $query;
        } catch (Exception $e) {
            return FALSE;
        }
    }

    function getEksekusi($year){
        try {
            $query = $this->db->query(" SELECT 
                                        SUM(CASE WHEN permohonanEsekusi IS NOT NULL THEN 1 ELSE 0 END) AS permohonaneksekusi,
                                        SUM(CASE WHEN  (
                                            (penetapanTeguranEksekusi IS NOT NULL OR penetapanTeguranEksekusi <> '0000-00-00') OR 
                                            (pelaksanaanTeguranEksekusi IS NOT NULL OR pelaksanaanTeguranEksekusi <> '0000-00-00') OR 
                                            (penetapanSitaEksekusi IS NOT NULL OR penetapanSitaEksekusi <> '0000-00-00') OR
                                            (pelaksanaanEksekusiLelang IS NOT NULL OR pelaksanaanEksekusiLelang <> '0000-00-00')
                                        )
                                        THEN 1 ELSE 0 END) AS pelaksanaaneksekusi
                                        FROM eksekusiweb
                                        WHERE 
                                        YEAR(permohonanEsekusi) = '".$year."';");
            return $query;
        } catch (Exception $e) {
            return FALSE;
        }
    }

    function getPosbakum($year){
        try {
            $query = $this->db2->query("SELECT   
                                        SUM(CASE WHEN jenis_laporan='13' THEN 1 ELSE 0 END) AS jumlah_record,
                                        SUM(CASE WHEN jenis_laporan='13' THEN pembilang ELSE 0 END) AS pembilang,
                                        SUM(CASE WHEN jenis_laporan='13' THEN penyebut ELSE 0 END) AS penyebut
                                        FROM trx_laporan
                                        WHERE (thn_bln_laporan >='".$year."-01' AND  thn_bln_laporan <='".$year."-12') AND jenis_laporan= '13'; ");
            return $query;
        } catch (Exception $e) {
            return FALSE;
        }
    }

    public function getValConfig($id){
        try {
            $query = $this->db2->query("SELECT * from sys_config where id='".$id."' ;");
            return $query;
        } catch (Exception $e) {
            return FALSE;
        }
    }

    





    

}
